USE AdventureWorks2012;
GO

SELECT DATEADD(MONTH, DATEDIFF(MONTH, GETDATE(), 0), 0),
       DATEADD(MONTH, DATEDIFF(MONTH, 0, GETDATE()), 0);
GO

CREATE TABLE dbo.DateTest
(
  CreateDate DATE
);
 
CREATE CLUSTERED INDEX x ON dbo.DateTest(CreateDate);
 
INSERT dbo.DateTest(CreateDate) 
SELECT TOP (15000) DATEADD(MONTH, DATEDIFF(MONTH, GETDATE(), 0), 0)
FROM sys.all_objects AS s1
CROSS JOIN sys.all_objects AS s2
UNION ALL
SELECT TOP (50) DATEADD(MONTH, DATEDIFF(MONTH, 0, GETDATE()), 0)
FROM sys.all_objects;

-- show in Plan Explorer
-- in particular, look at the first two queries, where
-- the CI scan has vastly different estimates. This does
-- not happen on 3 & 4.

SELECT /* Query 1 */ COUNT(*) FROM dbo.DateTest
  WHERE CreateDate = DATEADD(MONTH, DATEDIFF(MONTH, 0, GETDATE()), 0);
 
SELECT /* Query 2 */ COUNT(*) FROM dbo.DateTest
  WHERE CreateDate = DATEADD(MONTH, DATEDIFF(MONTH, GETDATE(), 0), 0);

SELECT /* Query 3 */ COUNT(*) FROM dbo.DateTest
  WHERE CreateDate = CONVERT(DATE, DATEADD(DAY, 1 - DAY(GETDATE()), GETDATE()));

SELECT /* Query 4 */ COUNT(*) FROM dbo.DateTest
  WHERE CreateDate = CONVERT(DATE, '1785-11-01');

DROP TABLE dbo.DateTest;
GO
